Handle Requests

TableSheet supports a self-defined function to configure the remote request options.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function.

The details of the data changes are in the Request and Response section of the Overview.

AutoSync Mode

Handle requests in the AutoSync mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    autoSync: true // enable the autoSync mode
    remote: {
        read: function (): Promise<any[]>{
            return requestToServer();
        },
        update: function (item): Promise<any>{ // the updated data change
            return requestToServer(item);
        },
        create: function (item): Promise<any>{ // the created data change
            return requestToServer(item);
        },
        delete: function (item): Promise<boolean>{ // the deleted data change
            return requestToServer(item);
        },
        // // not necessary if want to define the column
        // getColumns: function (): Promise<any[]>{
        //     return requestToServer();
        // },
        // addColumn: function (change): Promise<any>{ // the added column change
        //     return requestToServer(change);
        // },
        // updateColumn: function (change): Promise<any>{ // the updated column change
        //     return requestToServer(change);
        // },
        // removeColumn: function (change): Promise<boolean>{ // the removed column change
        //     return requestToServer(change);
        // },
    }
});

Batch Mode

Handle requests in the Batch mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    batch: true, // enable the batch mode
    remote: {
        // ... other settings
        batch: function (changes: any[]): Promise<any[]>{ // the added, updated, removed column changes and the created, updated, deleted data changes
            return requestToServer(changes);
        }
    }
});

Change data source options

When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again.

// 1. invoke Workbook's fromJSON
spread.fromJSON(spreadJson);
// 2. update table options
let myTable = spread.dataManager().tables["myTable"];
myTable.options = {
    remote: {
        read: function () {
            return Promise.resolve(dataSource);
        }
    }
};
//// make sure myTable.options be reset if just updating the properties of the options
// let options = myTable.options;
// options.remote.read.url = './new-url';
//// It could specify the GC.Data.IRemoteFetchOption(similar as RequestInit) to the options of the read property for the fetch options
// options.remote.read.options = { headers: { 'AuthenticationToken': 'fake_token' } };
// myTable.options = options; // It's important to reset the options to update


// 3. invoke table's fetch then setDataView
myTable.fetch(true).then(function() {
    let myView = myTable.views["myView"];
    let sheet = spread.getActiveSheetTab();
    sheet.setDataView(myView);
});

Reload data

When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again.

class GC.Data.Table {
    /**
     * Requests the table data from local data source or remote data source by the data source option.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}

And a View’s fetch method has same reload argument with a Table’s fetch method.

class GC.Data.View {
    /**
     * Requests the view data from its host table and related table.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}
By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function. The details of the data changes are in the Request and Response section of the Overview. AutoSync Mode Handle requests in the AutoSync mode: Batch Mode Handle requests in the Batch mode: Change data source options When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again. Reload data When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again. And a View’s fetch method has same reload argument with a Table’s fetch method.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ var tableName = "DefineEmployee"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; // var apiColumnUrl = baseApiUrl + "/tables/" + tableName + "/columns"; var batchApiUrl = baseApiUrl + "/" + tableName + 'Collection'; var tablesheetName = 'MyTableSheet'; var spread, sheet, view, selections, table; window.onload = function () { spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 }); initSpread(spread); bindEvents(); }; function sendRequest(url, options) { options.method = options.method || 'POST'; options.headers = { 'Content-Type': 'application/json; charset=utf-8' }; if (options.body) { options.body = JSON.stringify(options.body); } return fetch(url, options).then(resp => { if (resp.ok) { return resp.json(); } else { throw resp.statusText; } }); } function initSpread(spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: function () { return sendRequest(apiUrl, { method: 'GET' }); }, // update: function (item) { // return sendRequest(apiUrl, { body: item, method: 'PUT' }); // }, // create: function (item) { // return sendRequest(apiUrl, { body: item }); // }, // delete: function (item) { // return sendRequest(apiUrl, { body: item, method: 'DELETE' }); // }, // getColumns: function () { // return sendRequest(apiColumnUrl, { method: 'GET' }); // }, // updateColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'PUT' }); // }, // addColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change }); // }, // removeColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'DELETE' }); // }, batch: function (changes) { return sendRequest(batchApiUrl, { body: changes }); } }, batch: true, schema: { columns: { "Id": { dataType: "number" }, "LastName": { dataType: "string" }, "FirstName": { dataType: "string" }, "HomePhone": { dataType: "string" }, "Notes": { dataType: "string" } } } }); table = myTable; //init a table sheet sheet = spread.addSheetTab(0, tablesheetName, GC.Spread.Sheets.SheetType.tableSheet); // sheet.options.enableDefineColumn = true; var rowActions = GC.Spread.Sheets.TableSheet.BuiltInRowActions; var options = sheet.rowActionOptions(); options.push( rowActions.removeRow, rowActions.saveRow, rowActions.resetRow, ); sheet.rowActionOptions(options); //bind a view to the table sheet myTable.fetch().then(function () { view = myTable.addView("myView", [ { value: "Id", width: 50, caption: "ID" }, { value: "FirstName", width: 100, caption: "First Name" }, { value: "LastName", width: 100, caption: "Last Name" }, { value: "HomePhone", width: 100, caption: "Phone" }, { value: "Notes", width: 100, caption: "Notes" } ]); sheet.setDataView(view); }); spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function (e, args) { selections = args.newSelections; }); spread.resumePaint(); } function bindEvents() { var removeButton = document.getElementById('remove'); removeButton.addEventListener('click', function () { traverseSelectionsRowsWithOperation(function (row) { sheet.removeRow(row); }); }); var saveButton = document.getElementById('save'); saveButton.addEventListener('click', function () { traverseSelectionsRowsWithOperation(function (row) { sheet.saveRow(row); }); }); var resetButton = document.getElementById('reset'); resetButton.addEventListener('click', function () { traverseSelectionsRowsWithOperation(function (row) { sheet.resetRow(row); }); }); var saveAllButton = document.getElementById('save-all'); saveAllButton.addEventListener('click', function () { spread.commandManager().SaveAll.execute(spread, { sheetName: tablesheetName }); }); var submitButton = document.getElementById('submit'); submitButton.addEventListener('click', function () { sheet.submitChanges(); }); var discardButton = document.getElementById('discard'); discardButton.addEventListener('click', function () { sheet.cancelChanges(); }); } function traverseSelectionsRowsWithOperation(operation) { if (selections) { for (var i = 0; i < selections.length; i++) { var selection = selections[i]; var row = selection.row; var rowCount = selection.rowCount; for (var r = row + rowCount - 1; r >= row; r--) { operation(r); } } } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill --> <script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div id="options-container" class="options-container"> <fieldset> <legend>Active Row Operations</legend> <div class="field-line"> <input id="remove" type="button" value="Remove"> </div> <div class="field-line"> <input id="save" type="button" value="Save"> </div> <div class="field-line"> <input id="reset" type="button" value="Reset"> </div> </fieldset> <fieldset> <legend>Save All Rows</legend> <div class="field-line"> <input id="save-all" type="button" value="Save All"> </div> </fieldset> <fieldset> <legend>Batch Operations</legend> <div class="field-line"> <input type="button" value="Submit" id="submit"> </div> <div class="field-line"> <input type="button" value="Discard" id="discard"> </div> </fieldset> </div> </div> </html>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } fieldset { padding: 6px; margin: 0; margin-top: 10px; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } fieldset span, fieldset input, fieldset select { display: inline-block; text-align: left; } fieldset input[type=text] { width: calc(100% - 58px); } fieldset input[type=button] { width: 100%; text-align: center; } fieldset select { width: calc(100% - 50px); } .field-line { margin-top: 4px; } .field-inline { display: inline-block; vertical-align: middle; } fieldset label.field-inline { width: 100px; } fieldset input.field-inline { width: calc(100% - 100px - 12px); } .required { color: red; font-weight: bold; } #fields { display: none; } #fields.show { display: block; }

Handle Requests

TableSheet supports a self-defined function to configure the remote request options.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.jsx
app-func.jsx
app-class.jsx
index.html
styles.css
Copy to CodeMine

By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function.

The details of the data changes are in the Request and Response section of the Overview.

AutoSync Mode

Handle requests in the AutoSync mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    autoSync: true // enable the autoSync mode
    remote: {
        read: function (): Promise<any[]>{
            return requestToServer();
        },
        update: function (item): Promise<any>{ // the updated data change
            return requestToServer(item);
        },
        create: function (item): Promise<any>{ // the created data change
            return requestToServer(item);
        },
        delete: function (item): Promise<boolean>{ // the deleted data change
            return requestToServer(item);
        },
        // // not necessary if want to define the column
        // getColumns: function (): Promise<any[]>{
        //     return requestToServer();
        // },
        // addColumn: function (change): Promise<any>{ // the added column change
        //     return requestToServer(change);
        // },
        // updateColumn: function (change): Promise<any>{ // the updated column change
        //     return requestToServer(change);
        // },
        // removeColumn: function (change): Promise<boolean>{ // the removed column change
        //     return requestToServer(change);
        // },
    }
});

Batch Mode

Handle requests in the Batch mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    batch: true, // enable the batch mode
    remote: {
        // ... other settings
        batch: function (changes: any[]): Promise<any[]>{ // the added, updated, removed column changes and the created, updated, deleted data changes
            return requestToServer(changes);
        }
    }
});

Change data source options

When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again.

// 1. invoke Workbook's fromJSON
spread.fromJSON(spreadJson);
// 2. update table options
let myTable = spread.dataManager().tables["myTable"];
myTable.options = {
    remote: {
        read: function () {
            return Promise.resolve(dataSource);
        }
    }
};
//// make sure myTable.options be reset if just updating the properties of the options
// let options = myTable.options;
// options.remote.read.url = './new-url';
//// It could specify the GC.Data.IRemoteFetchOption(similar as RequestInit) to the options of the read property for the fetch options
// options.remote.read.options = { headers: { 'AuthenticationToken': 'fake_token' } };
// myTable.options = options; // It's important to reset the options to update


// 3. invoke table's fetch then setDataView
myTable.fetch(true).then(function() {
    let myView = myTable.views["myView"];
    let sheet = spread.getActiveSheetTab();
    sheet.setDataView(myView);
});

Reload data

When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again.

class GC.Data.Table {
    /**
     * Requests the table data from local data source or remote data source by the data source option.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}

And a View’s fetch method has same reload argument with a Table’s fetch method.

class GC.Data.View {
    /**
     * Requests the view data from its host table and related table.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}
By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function. The details of the data changes are in the Request and Response section of the Overview. AutoSync Mode Handle requests in the AutoSync mode: Batch Mode Handle requests in the Batch mode: Change data source options When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again. Reload data When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again. And a View’s fetch method has same reload argument with a Table’s fetch method.
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; import { App } from './app-class'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app')); // 2. Class Component sample // ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets } from '@mescius/spread-sheets-react'; import './styles.css'; var tableName = "DefineEmployee"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; // var apiColumnUrl = baseApiUrl + "/tables/" + tableName + "/columns"; var batchApiUrl = baseApiUrl + "/" + tableName + 'Collection'; var tablesheetName = 'MyTableSheet'; function sendRequest(url, options) { options.method = options.method || 'POST'; options.headers = { 'Content-Type': 'application/json; charset=utf-8' }; if (options.body) { options.body = JSON.stringify(options.body); } return fetch(url, options).then(resp => { if (resp.ok) { return resp.json(); } else { throw resp.statusText; } }); } const useState = React.useState; let spread = null; export function AppFunc() { const [tablesheet, setTablesheet] = useState(null); const [selections, setSelections] = useState(null); const initSpread = (currSpread) => { spread = currSpread; spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: function () { return sendRequest(apiUrl, { method: 'GET' }); }, // update: function (item) { // return sendRequest(apiUrl, { body: item, method: 'PUT' }); // }, // create: function (item) { // return sendRequest(apiUrl, { body: item }); // }, // delete: function (item) { // return sendRequest(apiUrl, { body: item, method: 'DELETE' }); // }, // getColumns: function () { // return sendRequest(apiColumnUrl, { method: 'GET' }); // }, // updateColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'PUT' }); // }, // addColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change }); // }, // removeColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'DELETE' }); // }, batch: function (changes) { return sendRequest(batchApiUrl, { body: changes }); } }, batch: true, schema: { columns: { "Id": { dataType: "number" }, "LastName": { dataType: "string" }, "FirstName": { dataType: "string" }, "HomePhone": { dataType: "string" }, "Notes": { dataType: "string" } } } }); //init a table sheet var sheet = spread.addSheetTab(0, tablesheetName, GC.Spread.Sheets.SheetType.tableSheet); // sheet.options.enableDefineColumn = true; setTablesheet(sheet); var rowActions = GC.Spread.Sheets.TableSheet.BuiltInRowActions; var options = sheet.rowActionOptions(); options.push( rowActions.removeRow, rowActions.saveRow, rowActions.resetRow, ); sheet.rowActionOptions(options); //bind a view to the table sheet myTable.fetch().then(function () { var view = myTable.addView("myView", [ { value: "Id", width: 50, caption: "ID" }, { value: "FirstName", width: 100, caption: "First Name" }, { value: "LastName", width: 100, caption: "Last Name" }, { value: "HomePhone", width: 100, caption: "Phone" }, { value: "Notes", width: 100, caption: "Notes" } ]); //the View has all default columns of the Table sheet.setDataView(view); }); spread.bind(GC.Spread.Sheets.Events.SelectionChanged, (e, args) => { setSelections(args.newSelections); }); spread.resumePaint(); } const removeRow = () => { traverseSelectionsRowsWithOperation((row) => { tablesheet.removeRow(row); }); } const saveRow = () => { traverseSelectionsRowsWithOperation((row) => { tablesheet.saveRow(row); }); } const resetRow = () => { traverseSelectionsRowsWithOperation((row) => { tablesheet.resetRow(row); }); } const saveAllRows = () => { spread.commandManager().SaveAll.execute(spread, { sheetName: tablesheetName }); } const submitChanges = () => { tablesheet.submitChanges(); } const discardChanges = () => { tablesheet.cancelChanges(); } const traverseSelectionsRowsWithOperation = (operation) => { if (selections) { for (var i = 0; i < selections.length; i++) { var selection = selections[i]; var row = selection.row; var rowCount = selection.rowCount; for (var r = row + rowCount - 1; r >= row; r--) { operation(r); } } } } return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => initSpread(spread)}></SpreadSheets> </div> <div id="options-container" class="options-container"> <fieldset> <legend>Active Row Operations</legend> <div class="field-line"> <input id="remove" type="button" value="Remove" onClick={() => { removeRow() }} /> </div> <div class="field-line"> <input id="save" type="button" value="Save" onClick={() => { saveRow() }} /> </div> <div class="field-line"> <input id="reset" type="button" value="Reset" onClick={() => { resetRow() }} /> </div> </fieldset> <fieldset> <legend>Save All Rows</legend> <div class="field-line"> <input id="save-all" type="button" value="Save All" onClick={() => { saveAllRows() }} /> </div> </fieldset> <fieldset> <legend>Batch Operations</legend> <div class="field-line"> <input type="button" value="Submit" id="submit" onClick={() => { submitChanges() }} /> </div> <div class="field-line"> <input type="button" value="Discard" id="discard" onClick={() => { discardChanges() }} /> </div> </fieldset> </div> </div> ); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets } from '@mescius/spread-sheets-react'; import './styles.css'; const Component = React.Component; var tableName = "DefineEmployee"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; // var apiColumnUrl = baseApiUrl + "/tables/" + tableName + "/columns"; var batchApiUrl = baseApiUrl + "/" + tableName + 'Collection'; var tablesheetName = 'MyTableSheet'; function sendRequest(url, options) { options.method = options.method || 'POST'; options.headers = { 'Content-Type': 'application/json; charset=utf-8' }; if (options.body) { options.body = JSON.stringify(options.body); } return fetch(url, options).then(resp => { if (resp.ok) { return resp.json(); } else { throw resp.statusText; } }); } export class App extends Component { constructor(props) { super(props); this.spread = null; this.tablesheet = null; this.selections = null; } render() { return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => this.initSpread(spread)}></SpreadSheets> </div> <div id="options-container" class="options-container"> <fieldset> <legend>Active Row Operations</legend> <div class="field-line"> <input id="remove" type="button" value="Remove" onClick={() => { this.removeRow() }} /> </div> <div class="field-line"> <input id="save" type="button" value="Save" onClick={() => { this.saveRow() }} /> </div> <div class="field-line"> <input id="reset" type="button" value="Reset" onClick={() => { this.resetRow() }} /> </div> </fieldset> <fieldset> <legend>Save All Rows</legend> <div class="field-line"> <input id="save-all" type="button" value="Save All" onClick={() => { this.saveAllRows() }} /> </div> </fieldset> <fieldset> <legend>Batch Operations</legend> <div class="field-line"> <input type="button" value="Submit" id="submit" onClick={() => { this.submitChanges() }} /> </div> <div class="field-line"> <input type="button" value="Discard" id="discard" onClick={() => { this.discardChanges() }} /> </div> </fieldset> </div> </div> ); } initSpread(spread) { this.spread = spread; spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: function () { return sendRequest(apiUrl, { method: 'GET' }); }, // update: function (item) { // return sendRequest(apiUrl, { body: item, method: 'PUT' }); // }, // create: function (item) { // return sendRequest(apiUrl, { body: item }); // }, // delete: function (item) { // return sendRequest(apiUrl, { body: item, method: 'DELETE' }); // }, // getColumns: function () { // return sendRequest(apiColumnUrl, { method: 'GET' }); // }, // updateColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'PUT' }); // }, // addColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change }); // }, // removeColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'DELETE' }); // }, batch: function (changes) { return sendRequest(batchApiUrl, { body: changes }); } }, batch: true, schema: { columns: { "Id": { dataType: "number" }, "LastName": { dataType: "string" }, "FirstName": { dataType: "string" }, "HomePhone": { dataType: "string" }, "Notes": { dataType: "string" } } } }); //init a table sheet var sheet = spread.addSheetTab(0, tablesheetName, GC.Spread.Sheets.SheetType.tableSheet); // sheet.options.enableDefineColumn = true; this.tablesheet = sheet; var rowActions = GC.Spread.Sheets.TableSheet.BuiltInRowActions; var options = sheet.rowActionOptions(); options.push( rowActions.removeRow, rowActions.saveRow, rowActions.resetRow, ); sheet.rowActionOptions(options); //bind a view to the table sheet myTable.fetch().then(function () { var view = myTable.addView("myView", [ { value: "Id", width: 50, caption: "ID" }, { value: "FirstName", width: 100, caption: "First Name" }, { value: "LastName", width: 100, caption: "Last Name" }, { value: "HomePhone", width: 100, caption: "Phone" }, { value: "Notes", width: 100, caption: "Notes" } ]); //the View has all default columns of the Table sheet.setDataView(view); }); spread.bind(GC.Spread.Sheets.Events.SelectionChanged, (e, args) => { this.selections = args.newSelections; }); spread.resumePaint(); } removeRow() { this.traverseSelectionsRowsWithOperation((row) => { this.tablesheet.removeRow(row); }); } saveRow() { this.traverseSelectionsRowsWithOperation((row) => { this.tablesheet.saveRow(row); }); } resetRow() { this.traverseSelectionsRowsWithOperation((row) => { this.tablesheet.resetRow(row); }); } saveAllRows() { this.spread.commandManager().SaveAll.execute(this.spread, { sheetName: tablesheetName }); } submitChanges() { this.tablesheet.submitChanges(); } discardChanges() { this.tablesheet.cancelChanges(); } traverseSelectionsRowsWithOperation(operation) { var selections = this.selections; if (selections) { for (var i = 0; i < selections.length; i++) { var selection = selections[i]; var row = selection.row; var rowCount = selection.rowCount; for (var r = row + rowCount - 1; r >= row; r--) { operation(r); } } } } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } fieldset { padding: 6px; margin: 0; margin-top: 10px; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } fieldset span, fieldset input, fieldset select { display: inline-block; text-align: left; } fieldset input[type=text] { width: calc(100% - 58px); } fieldset input[type=button] { width: 100%; text-align: center; } fieldset select { width: calc(100% - 50px); } .field-line { margin-top: 4px; } .field-inline { display: inline-block; vertical-align: middle; } fieldset label.field-inline { width: 100px; } fieldset input.field-inline { width: calc(100% - 100px - 12px); } .required { color: red; font-weight: bold; } #fields { display: none; } #fields.show { display: block; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

Handle Requests

TableSheet supports a self-defined function to configure the remote request options.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function.

The details of the data changes are in the Request and Response section of the Overview.

AutoSync Mode

Handle requests in the AutoSync mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    autoSync: true // enable the autoSync mode
    remote: {
        read: function (): Promise<any[]>{
            return requestToServer();
        },
        update: function (item): Promise<any>{ // the updated data change
            return requestToServer(item);
        },
        create: function (item): Promise<any>{ // the created data change
            return requestToServer(item);
        },
        delete: function (item): Promise<boolean>{ // the deleted data change
            return requestToServer(item);
        },
        // // not necessary if want to define the column
        // getColumns: function (): Promise<any[]>{
        //     return requestToServer();
        // },
        // addColumn: function (change): Promise<any>{ // the added column change
        //     return requestToServer(change);
        // },
        // updateColumn: function (change): Promise<any>{ // the updated column change
        //     return requestToServer(change);
        // },
        // removeColumn: function (change): Promise<boolean>{ // the removed column change
        //     return requestToServer(change);
        // },
    }
});

Batch Mode

Handle requests in the Batch mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    batch: true, // enable the batch mode
    remote: {
        // ... other settings
        batch: function (changes: any[]): Promise<any[]>{ // the added, updated, removed column changes and the created, updated, deleted data changes
            return requestToServer(changes);
        }
    }
});

Change data source options

When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again.

// 1. invoke Workbook's fromJSON
spread.fromJSON(spreadJson);
// 2. update table options
let myTable = spread.dataManager().tables["myTable"];
myTable.options = {
    remote: {
        read: function () {
            return Promise.resolve(dataSource);
        }
    }
};
//// make sure myTable.options be reset if just updating the properties of the options
// let options = myTable.options;
// options.remote.read.url = './new-url';
//// It could specify the GC.Data.IRemoteFetchOption(similar as RequestInit) to the options of the read property for the fetch options
// options.remote.read.options = { headers: { 'AuthenticationToken': 'fake_token' } };
// myTable.options = options; // It's important to reset the options to update


// 3. invoke table's fetch then setDataView
myTable.fetch(true).then(function() {
    let myView = myTable.views["myView"];
    let sheet = spread.getActiveSheetTab();
    sheet.setDataView(myView);
});

Reload data

When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again.

class GC.Data.Table {
    /**
     * Requests the table data from local data source or remote data source by the data source option.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}

And a View’s fetch method has same reload argument with a Table’s fetch method.

class GC.Data.View {
    /**
     * Requests the view data from its host table and related table.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}
By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function. The details of the data changes are in the Request and Response section of the Overview. AutoSync Mode Handle requests in the AutoSync mode: Batch Mode Handle requests in the Batch mode: Change data source options When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again. Reload data When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again. And a View’s fetch method has same reload argument with a Table’s fetch method.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { FormsModule } from '@angular/forms'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import './styles.css'; var tableName = "DefineEmployee"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; // var apiColumnUrl = baseApiUrl + "/tables/" + tableName + "/columns"; var batchApiUrl = baseApiUrl + "/" + tableName + 'Collection'; var tablesheetName = 'MyTableSheet'; function sendRequest(url: string, options: any) { options.method = options.method || 'POST'; options.headers = { 'Content-Type': 'application/json; charset=utf-8' }; if (options.body) { options.body = JSON.stringify(options.body); } return fetch(url, options).then(resp => { if (resp.ok) { return resp.json(); } else { throw resp.statusText; } }); } @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { methods4html = { objectKeys: Object.keys, number: Number }; spread: GC.Spread.Sheets.Workbook; tablesheet: GC.Spread.Sheets.TableSheet; fields = {}; selections; isEdit = false; hostStyle = { width: "calc(100% - 280px)", height: "100%", overflow: "hidden", float: "left" }; constructor() { } initSpread($event: any) { let spread = $event.spread; this.spread = spread; spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: function () { return sendRequest(apiUrl, { method: 'GET' }); }, // update: function (item) { // return sendRequest(apiUrl, { body: item, method: 'PUT' }); // }, // create: function (item) { // return sendRequest(apiUrl, { body: item }); // }, // delete: function (item) { // return sendRequest(apiUrl, { body: item, method: 'DELETE' }); // }, // getColumns: function () { // return sendRequest(apiColumnUrl, { method: 'GET' }); // }, // updateColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'PUT' }); // }, // addColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change }); // }, // removeColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'DELETE' }); // }, batch: function (changes: any[]) { return sendRequest(batchApiUrl, { body: changes }); } }, batch: true, schema: { columns: { "Id": { dataType: "number" }, "LastName": { dataType: "string" }, "FirstName": { dataType: "string" }, "HomePhone": { dataType: "string" }, "Notes": { dataType: "string" } } } }); //init a table sheet var sheet = spread.addSheetTab(0, tablesheetName, GC.Spread.Sheets.SheetType.tableSheet); // sheet.options.enableDefineColumn = true; this.tablesheet = sheet; var rowActions = GC.Spread.Sheets.TableSheet.BuiltInRowActions; var options = sheet.rowActionOptions(); options.push( rowActions.removeRow, rowActions.saveRow, rowActions.resetRow, ); sheet.rowActionOptions(options); //bind a view to the table sheet myTable.fetch().then(function() { var view = myTable.addView("myView", [ { value: "Id", width: 50, caption: "ID" }, { value: "FirstName", width: 100, caption: "First Name" }, { value: "LastName", width: 100, caption: "Last Name" }, { value: "HomePhone", width: 100, caption: "Phone" }, { value: "Notes", width: 100, caption: "Notes" } ]); //the View has all default columns of the Table sheet.setDataView(view); }); spread.bind(GC.Spread.Sheets.Events.SelectionChanged, (e, args) => { this.selections = args.newSelections; }); spread.resumePaint(); } removeRow() { this.traverseSelectionsRowsWithOperation((row) => { this.tablesheet.removeRow(row); }); } saveRow() { this.traverseSelectionsRowsWithOperation((row) => { this.tablesheet.saveRow(row); }); } resetRow() { this.traverseSelectionsRowsWithOperation((row) => { this.tablesheet.resetRow(row); }); } saveAllRows() { this.spread.commandManager().SaveAll.execute(this.spread, { sheetName: tablesheetName }); } submitChanges() { this.tablesheet.submitChanges(); } discardChanges() { this.tablesheet.cancelChanges(); } traverseSelectionsRowsWithOperation(operation) { var selections = this.selections; if (selections) { for (var i = 0; i < selections.length; i++) { var selection = selections[i]; var row = selection.row; var rowCount = selection.rowCount; for (var r = row + rowCount - 1; r >= row; r--) { operation(r); } } } } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } @NgModule({ imports: [BrowserModule, SpreadSheetsModule, FormsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"></gc-spread-sheets> <div id="options-container" class="options-container"> <fieldset> <legend>Active Row Operations</legend> <div class="field-line"> <input id="remove" type="button" value="Remove" (click)="removeRow()"> </div> <div class="field-line"> <input id="save" type="button" value="Save" (click)="saveRow()"> </div> <div class="field-line"> <input id="reset" type="button" value="Reset" (click)="resetRow()"> </div> </fieldset> <fieldset> <legend>Save All Rows</legend> <div class="field-line"> <input id="save-all" type="button" value="Save All" (click)="saveAllRows()"> </div> </fieldset> <fieldset> <legend>Batch Operations</legend> <div class="field-line"> <input type="button" value="Submit" id="submit" (click)="submitChanges()"> </div> <div class="field-line"> <input type="button" value="Discard" id="discard" (click)="discardChanges()"> </div> </fieldset> </div> </div>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } fieldset { padding: 6px; margin: 0; margin-top: 10px; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } fieldset span, fieldset input, fieldset select { display: inline-block; text-align: left; } fieldset input[type=text] { width: calc(100% - 58px); } fieldset input[type=button] { width: 100%; text-align: center; } fieldset select { width: calc(100% - 50px); } .field-line { margin-top: 4px; } .field-inline { display: inline-block; vertical-align: middle; } fieldset label.field-inline { width: 100px; } fieldset input.field-inline { width: calc(100% - 100px - 12px); } .required { color: red; font-weight: bold; } #fields { display: none; } #fields.show { display: block; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

Handle Requests

TableSheet supports a self-defined function to configure the remote request options.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.vue
index.html
Copy to CodeMine

By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function.

The details of the data changes are in the Request and Response section of the Overview.

AutoSync Mode

Handle requests in the AutoSync mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    autoSync: true // enable the autoSync mode
    remote: {
        read: function (): Promise<any[]>{
            return requestToServer();
        },
        update: function (item): Promise<any>{ // the updated data change
            return requestToServer(item);
        },
        create: function (item): Promise<any>{ // the created data change
            return requestToServer(item);
        },
        delete: function (item): Promise<boolean>{ // the deleted data change
            return requestToServer(item);
        },
        // // not necessary if want to define the column
        // getColumns: function (): Promise<any[]>{
        //     return requestToServer();
        // },
        // addColumn: function (change): Promise<any>{ // the added column change
        //     return requestToServer(change);
        // },
        // updateColumn: function (change): Promise<any>{ // the updated column change
        //     return requestToServer(change);
        // },
        // removeColumn: function (change): Promise<boolean>{ // the removed column change
        //     return requestToServer(change);
        // },
    }
});

Batch Mode

Handle requests in the Batch mode:

function requestToServer(params?): Promise<any> {
    // api of request to server
}

var myTable = dataManager.addTable("myTable", {
    // ... other settings
    batch: true, // enable the batch mode
    remote: {
        // ... other settings
        batch: function (changes: any[]): Promise<any[]>{ // the added, updated, removed column changes and the created, updated, deleted data changes
            return requestToServer(changes);
        }
    }
});

Change data source options

When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again.

// 1. invoke Workbook's fromJSON
spread.fromJSON(spreadJson);
// 2. update table options
let myTable = spread.dataManager().tables["myTable"];
myTable.options = {
    remote: {
        read: function () {
            return Promise.resolve(dataSource);
        }
    }
};
//// make sure myTable.options be reset if just updating the properties of the options
// let options = myTable.options;
// options.remote.read.url = './new-url';
//// It could specify the GC.Data.IRemoteFetchOption(similar as RequestInit) to the options of the read property for the fetch options
// options.remote.read.options = { headers: { 'AuthenticationToken': 'fake_token' } };
// myTable.options = options; // It's important to reset the options to update


// 3. invoke table's fetch then setDataView
myTable.fetch(true).then(function() {
    let myView = myTable.views["myView"];
    let sheet = spread.getActiveSheetTab();
    sheet.setDataView(myView);
});

Reload data

When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again.

class GC.Data.Table {
    /**
     * Requests the table data from local data source or remote data source by the data source option.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}

And a View’s fetch method has same reload argument with a Table’s fetch method.

class GC.Data.View {
    /**
     * Requests the view data from its host table and related table.
     * @param {boolean} [reload] Whether to reload the data from server side forcibly.
     * @returns {Promise} The resolving Promise thenable. You could get the data in Promise.then().
     */
    fetch (reload?: boolean): Promise<any>;
}
By default, the TableSheet will configure the remote requests by an object. If you want to handle the request manually, just replace the object of the function, and the data and column changes will be passed to the function. The details of the data changes are in the Request and Response section of the Overview. AutoSync Mode Handle requests in the AutoSync mode: Batch Mode Handle requests in the Batch mode: Change data source options When a Table uses CRUD functions instead of CRUD options, these functions can't be saved and restored after JSON serialization / deserialization because of security issue. Setting the Table’s data source options after the fromJSON method is invoked could make the Table working again. Reload data When a Table’s fetch method is invoked and its reload argument is true, the Table will load data again. And a View’s fetch method has same reload argument with a Table’s fetch method.
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> <div id="options-container" class="options-container"> <fieldset> <legend>Active Row Operations</legend> <div class="field-line"> <input id="remove" type="button" value="Remove" @click="removeRow()"> </div> <div class="field-line"> <input id="save" type="button" value="Save" @click="saveRow()"> </div> <div class="field-line"> <input id="reset" type="button" value="Reset" @click="resetRow()"> </div> </fieldset> <fieldset> <legend>Save All Rows</legend> <div class="field-line"> <input id="save-all" type="button" value="Save All" @click="saveAllRows()"> </div> </fieldset> <fieldset> <legend>Batch Operations</legend> <div class="field-line"> <input type="button" value="Submit" id="submit" @click="submitChanges()"> </div> <div class="field-line"> <input type="button" value="Discard" id="discard" @click="discardChanges()"> </div> </fieldset> </div> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import { ref } from "vue"; import "@mescius/spread-sheets-tablesheet"; import "@mescius/spread-sheets-vue"; var tableName = "DefineEmployee"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; // var apiColumnUrl = baseApiUrl + "/tables/" + tableName + "/columns"; var batchApiUrl = baseApiUrl + "/" + tableName + 'Collection'; var tablesheetName = 'MyTableSheet'; function sendRequest(url, options) { options.method = options.method || 'POST'; options.headers = { 'Content-Type': 'application/json; charset=utf-8' }; if (options.body) { options.body = JSON.stringify(options.body); } return fetch(url, options).then(resp => { if (resp.ok) { return resp.json(); } else { throw resp.statusText; } }); } const spreadRef = ref(null); const tablesheet = ref(null); const selections = ref([{ row: 0, rowCount: 1, col: 0, colCount: 1 }]); function initSpread(spread) { spreadRef.value = spread; spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: function readFunction() { return sendRequest(apiUrl, { method: 'GET' }); }, // update: function (item) { // return sendRequest(apiUrl, { body: item, method: 'PUT' }); // }, // create: function (item) { // return sendRequest(apiUrl, { body: item }); // }, // delete: function (item) { // return sendRequest(apiUrl, { body: item, method: 'DELETE' }); // }, // getColumns: function () { // return sendRequest(apiColumnUrl, { method: 'GET' }); // }, // updateColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'PUT' }); // }, // addColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change }); // }, // removeColumn: function (change) { // return sendRequest(apiColumnUrl, { body: change, method: 'DELETE' }); // }, batch: function batchFunction(changes) { return sendRequest(batchApiUrl, { body: changes }); } }, batch: true, schema: { columns: { "Id": { dataType: "number" }, "LastName": { dataType: "string" }, "FirstName": { dataType: "string" }, "HomePhone": { dataType: "string" }, "Notes": { dataType: "string" } } } }); //init a table sheet var sheet = spread.addSheetTab(0, tablesheetName, GC.Spread.Sheets.SheetType.tableSheet); // sheet.options.enableDefineColumn = true; tablesheet.value = sheet; var rowActions = GC.Spread.Sheets.TableSheet.BuiltInRowActions; var options = sheet.rowActionOptions(); options.push( rowActions.removeRow, rowActions.saveRow, rowActions.resetRow, ); sheet.rowActionOptions(options); //bind a view to the table sheet myTable.fetch().then(function () { var view = myTable.addView("myView", [{ value: "Id", width: 50, caption: "ID" }, { value: "FirstName", width: 100, caption: "First Name" }, { value: "LastName", width: 100, caption: "Last Name" }, { value: "HomePhone", width: 100, caption: "Phone" }, { value: "Notes", width: 100, caption: "Notes" } ]); //the View has all default columns of the Table sheet.setDataView(view); }); spread.bind(GC.Spread.Sheets.Events.SelectionChanged, (e, args) => { selections.value = args.newSelections; }); spread.resumePaint(); } function removeRow() { traverseSelectionsRowsWithOperation((row) => { tablesheet.value.removeRow(row); }); } function saveRow() { traverseSelectionsRowsWithOperation((row) => { tablesheet.value.saveRow(row); }); } function resetRow() { traverseSelectionsRowsWithOperation((row) => { tablesheet.value.resetRow(row); }); } function saveAllRows() { spreadRef.value.commandManager().SaveAll.execute(spreadRef.value, { sheetName: tablesheetName }); } function submitChanges() { tablesheet.value.submitChanges(); } function discardChanges() { tablesheet.value.cancelChanges(); } function traverseSelectionsRowsWithOperation(operation) { var selectionsList = selections.value; if (selectionsList) { for (var i = 0; i < selectionsList.length; i++) { var selection = selectionsList[i]; var row = selection.row; var rowCount = selection.rowCount; for (var r = row + rowCount - 1; r >= row; r--) { operation(r); } } } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } </script> <style scoped> #app { height: 100%; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } fieldset { padding: 6px; margin: 0; margin-top: 10px; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } fieldset span, fieldset input, fieldset select { display: inline-block; text-align: left; } fieldset input[type=text] { width: calc(100% - 58px); } fieldset input[type=button] { width: 100%; text-align: center; } fieldset select { width: calc(100% - 50px); } .field-line { margin-top: 4px; } .field-inline { display: inline-block; vertical-align: middle; } fieldset label.field-inline { width: 100px; } fieldset input.field-inline { width: calc(100% - 100px - 12px); } .required { color: red; font-weight: bold; } #fields { display: none; } #fields.show { display: block; } #changesPanel { width: 100%; height: 300px; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);